<template>
    <Container ref="master-parent" :max-height="type === 'width' ? null :  ratio"
               :style="ParentStyle">
        <q-resize-observer @resize="AdjustSizes"/>
        <div v-if='Render' class="relative-position" :style="RectangleDimensions">
            <img :src="Image" v-if="Render" alt="Please upload a floorplan" class="fit fp-img"/>
            <FloorPlanCanvas v-if="Render"
                             :painter-config="PainterConfig"
                             :colored-floor-plan="ColoredFloorPlan"
                             class="top-canvas"/>
            <FloorPlanTextRender v-if="Render && FloorPlanSettings.StoreValue.showZoneText"
                                 class="fp-text"
                                 :width="floorPlanW"
                                 :height="floorPlanH"
                                 :color="FloorPlanSettings.StoreValue.zoneTextColor"
                                 :font-size="FloorPlanSettings.StoreValue.zoneTextSize"
                                 :colored-floor-plan="ColoredFloorPlan"
            />
            <FloorPlanWorkerRenderer v-if="Render && this.FloorPlanSettings.StoreValue.showWorkers" class="fp-worker"
                                     @select-worker="$emit('select-worker', $event)"
                                     :label-border-color="FloorPlanSettings.StoreValue.workerLabelBorderColor"
                                     :label-border-size="FloorPlanSettings.StoreValue.workerLabelBorderSize"
                                     :compare-time="compareTime"
                                     :fp-h="floorPlan.info.height"
                                     :fp-w="floorPlan.info.width"
                                     :workers="workers"
                                     :width="floorPlanW" :height="floorPlanH"
                                     :pulse="FloorPlanSettings.StoreValue.pulse"
                                     :color-mode="FloorPlanSettings.StoreValue.workerColorMode"
                                     :display-inactive="FloorPlanSettings.StoreValue.workerDisplayInactive"
                                     :label-shape="FloorPlanSettings.StoreValue.workerLabelShape"
                                     :dot-size="FloorPlanSettings.StoreValue.workerDotSize"
                                     :label-mode="FloorPlanSettings.StoreValue.workerLabelMode"
                                     :inactive-duration="FloorPlanSettings.StoreValue.workerInactiveDuration"
                                     :label-size="FloorPlanSettings.StoreValue.workerLabelSize"
                                     :label-color="FloorPlanSettings.StoreValue.workerLabelColor"
                                     :label-background-color="FloorPlanSettings.StoreValue.workerLabelBackgroundColor"
                                     :label-background-opacity="FloorPlanSettings.StoreValue.workerLabelBackgroundTransparency"
                                     :selected="selected"
                                     :hovered="hovered"
            />
        </div>
    </Container>
</template>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import {FloorPlanFullResponse} from "src/classLibrary/APIModels/core/floorPlanFullResponse";
import {InputZone} from "src/classLibrary/Geometry/ZoneMapper";
import {InputExit} from "src/classLibrary/Geometry/ExitMapper";
import {FloorPlanMapper} from "src/classLibrary/Geometry/FloorPlanMapper";
import Container from "components/Core/Container.vue";
import FloorPlanCanvas from "components/FloorPlan/FloorPlanCanvas.vue";
import FloorPlanTextRender from "components/FloorPlan/FloorPlanTextRender.vue";
import {ColoredFloorPlanData} from "src/classLibrary/Geometry/Colored";
import {ColoredMapper} from "src/classLibrary/Geometry/ColoredMapper";
import {WorkerPositionResponse} from "src/classLibrary/APIModels/core/workerPositionResponse";
import FloorPlanWorkerRenderer from "components/FloorPlan/FloorPlanWorkerRenderer.vue";
import {PainterConfig} from "src/classLibrary/Geometry/Painter";

type Dimensions = [Map<string, InputZone>, Map<string, InputExit>, number, number];
@Component({
    components: {FloorPlanWorkerRenderer, FloorPlanTextRender, FloorPlanCanvas, Container}
})
export default class FloorPlanRender extends Vue {

    @Prop() compareTime!: Date;
    @Prop() floorPlan!: FloorPlanFullResponse;
    @Prop() workers!: { [s: string]: WorkerPositionResponse }
    @Prop() selected!: WorkerPositionResponse | null;
    @Prop() hovered!: WorkerPositionResponse | null;
    @Prop() type!: 'width' | 'height';
    @Prop() ratio!: number;

    floorPlanW: number = 1;
    floorPlanH: number = 1;

    get Render() {
        return this.Image != '';
    }

    get ByWidth() {
        return this.type === 'width';
    }

    get ColoredFloorPlan(): ColoredFloorPlanData {
        const mapper = new ColoredMapper(this.FloorPlanSettings.StoreValue.zoneColorMode);
        const [z, e, w, h] = this.Dimensions;
        const out = mapper.To(w, h, z, e);
        return out.Data;
    }

    AdjustSizes() {
        const p = (this.$refs['master-parent'] as Vue).$el;
        const [, , width, height] = this.Dimensions;
        if (this.ByWidth) {
            const w = p.getBoundingClientRect().width;
            const h = w / width * height;
            this.floorPlanW = w;
            this.floorPlanH = h;
        } else {
            const h = p.getBoundingClientRect().height;
            this.floorPlanW = h / height * width;
            this.floorPlanH = h;
        }
        this.$emit('update', this.RectStyle);
    }

    get PainterConfig(): PainterConfig {
        return {
            width: this.floorPlanW,
            height: this.floorPlanH,
            exitAlpha: 1,
            exitWidth: 5,
            drawExit: this.FloorPlanSettings.StoreValue.drawExit,
            drawZone: this.FloorPlanSettings.StoreValue.showZone,
            showDanger: this.FloorPlanSettings.StoreValue.showDanger,
            dangerIntensity: (11 - this.FloorPlanSettings.StoreValue.dangerIntensity) * 10,
            zoneAlpha: this.FloorPlanSettings.StoreValue.zoneAlpha
        }
    }

    get ParentStyle() {
        if (this.ByWidth) {
            return {
                width: (this.ratio * 100) + '%',
                position: 'relative',
            }
        } else {
            return {
                position: 'relative',
            }
        }
    }

    get RectStyle() {
        if (this.ByWidth) {
            return {
                width: (this.ratio * 100) + '%',
            }
        } else {
            return this.RectangleDimensions;
        }
    }

    get RectangleDimensions() {
        const width = this.floorPlanW + "px";
        const height = this.floorPlanH + "px";
        return {
            width,
            height,
        }
    }


    get Image() {
        return this.floorPlan.info.image;
    }

    get Dimensions(): Dimensions {
        return FloorPlanMapper.From(this.floorPlan);
    }


}
</script>

<style lang='scss' scoped>
.fp-img {
    position: absolute;
    z-index: 1;
}

.fp-text {
    position: absolute;
    top: 0;
    z-index: 3;
}

.fp-worker {
    position: absolute;
    top: 0;
    z-index: 4;
}

.top-canvas {
    position: absolute;
    top: 0;
    z-index: 2;
}
</style>
